双子生成器 Mk_1.3
===========================

#### オンライン説明書もあります

makrdown形式に慣れない方は、[オンライン説明書](https://rdnt.kiwi-bird.xyz)の方が見やすくて良いかもしれません。

### このプログラムについて

双子を作るには、AudacityをインストールしてRAMEを入れて、トーンを生成して合成して...とにかく手順が多かったりします。
慣れていないと面倒臭いことこの上ないので、全自動で制作するプログラムを書きました。

GUIプログラミングが出来ないので、DOS窓的な黒い画面が出てきますが特に悪いことはしていないはずです...

#### 仕様とか利用したモジュールとか

- [Python3.6.5(32bit)](https://www.python.org/)
	- 利用モジュールは`requirements.txt`に纏めてあります。
- [ffmpeg](https://www.ffmpeg.org/)
- 双子の仕様(default)
    - ビットレート = 16
    - サンプリング周波数 = 44100Hz
    - ベース周波数 = 100Hz
    - ステレオ
        - 左100Hz, 右105Hz
- (多分)読み込める音声ファイル
    - mp3
    - aac
    - m4a
    - mp4
    - ogg
    - wmv
    - wma
    - flv

#### 使い方

##### windowsの場合

1. もしも`双子生成器Mk_1.1.exe`と同じフォルダに`ffmpeg.exe`が存在しない場合は、[ffmepg公式サイト](https://www.ffmpeg.org/)よりダウンロードして下さい。
2. [ffmepg公式サイト](https://www.ffmpeg.org/)よりwindows用のファイルをDLして解凍したら、`bin`フォルダ以下にある`ffmpeg.exe`を`双子生成器Mk_1.1.exe`と同じフォルダに移動させて下さい。
    - もしくは`ffmpeg.exe`が存在するフォルダに環境変数(PATH)を通して下さい。
3. `双子生成器Mk_1.1.exe`を実行して下さい。
4. 初回起動の場合、`input`, `output`, `resource`フォルダが生成されます。そうしたら1度プログラムを閉じて下さい。
5. `input`フォルダの中に、双子にしたい音声ファイルを入れて下さい。
	- 大きめの音声ファイルは読み込み時にメモリリークが発生して失敗します。現時点では解決不可能な仕様なので我慢して下さい。
	- 複数ある場合は順番に読み込みます。
6. `output`フォルダに双子化された音声ファイルが出力されます。

※ 読み込み、書き出しにはしばらく時間がかかりますので、黒い画面で止まっても不安に思わないで下さい。

##### ソースコードから実行(開発者向け)

※基本的に同じですが、事前に最新版のPython3のインストールと関連モジュール(requirements.txtに記載)のインストール、あと`ffmpeg`が必要なのでDLしてPATH通しておいて下さい。

1. Python3のインストール
	- [python.org](https://www.python.org/)から対応するOSのインストーラを選んでインストールして下さい。PATHを通すのを忘れないようにして下さい。
2. モジュールのインストール
	- コマンドラインから下記のコマンドを実行して下さい。
	- `pip install -r requirements.txt`
		- コマンドが見つからない...的なエラーが出た場合、多分**PATH**を通し忘れています。
3. ffmpegのダウンロードとPATH通し作業
	- [ffmpeg](https://www.ffmpeg.org/)をダウンロードして、解答してから任意のフォルダに置いて下さい。配置したフォルダへPATHを通しておいて下さい。
4. 後はwindowsの場合と共通です。


config.json
---------------------------

config.jsonは初めて本プログラムを起動した時に自動的に作成される設定ファイルです。
こちらを弄ることで本プログラムの挙動をある程度変更することが出来ます。

ちゃんとテストしてるわけでもないので、下手に弄ると動かなくなるかもしれません。
その場合は`config.json`を削除して下さい。次回起動時に再度デフォルトのパラメータで生成されます。

※以下は解説向けにコメントを加えたものですが、jsonにはコメント機能が無いらしいので、以下をコピーしても動かないはずです。

```json
{	
    # フォルダ関連
    "input_dir": "input", # 双子化したい音声ファイルを格納するフォルダの名前
    "output_dir": "output", # 双子化した音声ファイルを出力するフォルダの名前
    "resource_dir": "resource", # プログラムの実行に利用するバイナリファイル群を格納しておくフォルダの名前
    
    # 双子音声の設定関連((開発者も詳しくないので)触らぬ神に祟りなし...)
    ## bit_rate * sampling_rate * channel == 1411KHz(wav品質)です。
    "bit_rate": 16,
    "sin_wav": 1.0,
    "sampling_rate": 44100,
    "base_sampling_rate": 100, # 双子の規定周波数です。高いほど高音になります。100でも結構低い感じ。
    "channel": 1, # 変更しちゃ駄目です。
    "difference": 5, # 左右のチャンネルの周波数の差です。
    				 # 例えば"difference"が"5"で"base_sampling_rate"が"100"の場合、左100Hz右105Hzの差になります。
                     
    "volume": 0, # 音量です。base_sampling_rateにもよりますが、-25から-15くらいが丁度いい気がします。
    "sound_sec_limited": 1800, # sound_sec_limitedを超える秒数の双子を出力することは出来ません。メモリリークで死ぬからです。
    
    # エフェクト
    "enable_fadein": false, # trueならフェードインエフェクトを許可します。　true / false
    "enable_fadeout": false, # trueならフェードアウトエフェクトを許可します。　true / false
    "fadein_duration": 3500, # フェードインエフェクトの秒数です。3500なら開始から3.5秒かけて徐々に規定の音量へと上昇していきます。
    "fadeout_duration": 3500, # フェードアウトエフェクトの秒数です。3500なら、終わりの3.5秒前から徐々にミュートへと音量が下がっていきます。
    
    # 読み込む音声ファイルの拡張子
    # 読み込みたくない拡張子があれば削除して下さい。
    "ext": [
        ".mp3",
        ".aac",
        ".m4a",
        ".mp4",
        ".ogg",
        ".wav",
        ".wma",
        ".flv"
    ],
    
    # 特殊動作
    "is_file_move_flag": false, # true なら、プログラム終了後にoutputフォルダ内のファイルを"file_moved_dist_path"へと移動します。
    "file_moved_dist_path": "" # デフォルトだと空白なので、"is_file_move_flag"をtrueにしてから、お好みで移動先のフォルダを指定して入力して下さい。
}
```

トラブルシュート
---------------------------
動かなくなったり突然プログラムが終了したりする場合は以下のフォルダとファイルを削除してみて下さい。

- `input`
- `output`
- `resource`
- `config.json`

`双子生成器mk1.exe`と同一のフォルダに`ffmpeg.exe`が存在しないと正しく動作しません。以下の内、１つ以上の処置を実行して下さい。

- [公式サイト](https://www.ffmpeg.org/)から`ffmpeg`をダウンロードして下さい。解凍後に`bin/`にある`ffmpeg.exe`を切り取って双子生成器mk1.exeと同じフォルダに移動させて下さい。
- `ffmpeg.exe`をダウンロード後に任意のフォルダに展開し、そこに**PATH**を通して下さい。
- こちらから[再ダウンロード](https://my.pcloud.com/publink/show?code=XZxbtb7ZHxtobz4c3ljh5s13AKpxijS9p0HV)して下さい。

上記を試しても動かない場合、間違いなくバグっているので掲示板か名倉で教えて下さい...

約束ごと
---------------------------

- 本プログラムは開発中です。なにか欲しい機能とかがあれば教えて下さい。
- 本プログラムを利用したことで発生したあらゆる問題に対し、開発者は一切責任を負いません。
- 本プログラムはGPLv3に準拠しています。再配布やソースの改造を自由に行って頂いて構いませんが、以下の点にご注意下さい。
	- 著作権を放棄しているわけではありません。
	- 再配布や改造を行ってインターネット上に公開した場合、ソースコードを必ず公開して下さいね。
		- ソースコードは**無償**で公開して下さい。
		- あくまで個人的な利用に留まる場合は公開しなくても大丈夫です。

連絡先
---------------------------
- [Operation KiWi](https://www.kiwi-bird.xyz/)
- [オンライン説明書](https://rdnt.kiwi-bird.xyz/)
- blackhole@kiwi-bird.xyz
